### Name: simulation
### Title: Simulate the data in form of p-values
### Aliases: simulation
### Keywords: misc

### ** Examples

data = simulation(n=500,GammaA=1,GammaB=1,r1=0.5,r2=0.8,DEfirst=300,DEsecond=200,DEcommon=100)

## The function is currently defined as
function(n,GammaA,GammaB,epsilonM=0, epsilonSD=1, r1,r2,DEfirst,DEsecond,DEcommon){

T1=c()
T2=c()
delta=rgamma(n,GammaA,1/GammaB)
epsilon1=rnorm(n,epsilonM,epsilonSD)
epsilon2=rnorm(n,epsilonM,epsilonSD)
names=c()
#Group 1 : DE in common
for(i in 1: DEcommon){
x=rbinom(1,1,0.5)
if(x==1) {
    T1[i] <- delta[i] + epsilon1[i]*r1;
    T2[i] <- delta[i] + epsilon2[i]*r2
  }
if(x==0) {T1[i] <- -delta[i] - epsilon1[i]*r1;
    T2[i] <- -delta[i] - epsilon2[i]*r2}

names[i] <- "DEcommon"
  }

#Group 2 : DE in the first experiment
for(i in (DEcommon+1):(DEfirst)){
x=rbinom(1,1,0.5)
if(x==1){
T1[i] <- delta[i] + epsilon1[i]*r1
  }
if(x==0){T1[i] <- -delta[i] - epsilon1[i]*r1}
T2[i] <- epsilon2[i]*r2
names[i] <- "DEfirst"
  }

#Group 3 : DE in the second experiment
for(i in (DEfirst+1):(DEfirst+DEsecond-DEcommon)){
x=rbinom(1,1,0.5)
T1[i] <- epsilon1[i]*r1
if(x==1){
T2[i] <- delta[i] + epsilon2[i]*r2
  }
if(x==0){T2[i] <- -delta[i] - epsilon2[i]*r2}
names[i] <- "DEsecond"

  }

#Group 4 : Not DE in Both experiments
for(i in (DEfirst+DEsecond-DEcommon+1):(n)){
T1[i] <- epsilon1[i]*r1
T2[i] <- epsilon2[i]*r2
names[i] <- "Null"
  }

##############################################
#Assign the Pvalues

Pval1 = c()
Pval2 = c()

for(i in 1:n){
Pval1[i] <- 2*pnorm(-abs(T1[i]/r1))
Pval2[i] <- 2*pnorm(-abs(T2[i]/r2))
#Pval1[i] <- 1-pnorm(T1[i]/r1)
#Pval2[i] <- 1-pnorm(T2[i]/r2)
  }

##############################################
return(list(names=names,T1=T1,T2=T2,Pval=cbind(Pval1,Pval2)))
  }



